/*
  30.01.2005:
  I adapted the definition of store_model
  (necessary for the inclusion of HISTORY
   information to output catalogs of astrom)

  11.03.2005:
  I adapted the definition of save_distort_tab
  (necessary for the inclusion of HISTORY
   information to output catalogs of astrom)
*/

#ifndef __ASTROM_IO_GLOBALS_H__
#define __ASTROM_IO_GLOBALS_H__

#include "astrom_io_types.h"
extern void	init_pairs(char *, model_struct  *),
		free_refpairs(reflist_struct *),
		free_overpairs(overlist_struct *),
		open_catalogs(model_struct *),
		prepare_correl(model_struct *, float *, short int *, float),
		assemble_correl(model_struct *, float *, short int *,
		                float, float),
		store_model(model_struct *, thresh_struct *, option *, 
		            int, char **),
		fetch_model(tabstruct *, model_struct *, thresh_struct **),
		add_distort_line(int, int, float **, int, model_struct *),
		init_distort_tab(model_struct *),
		init_residuals(char *, option *, char *),
		finish_residuals(),
		save_distort_tab(catstruct *, char *, int, char *, int, char **);

extern reflist_struct	*new_refpairs();
extern overlist_struct	*new_overpairs();
extern int	get_refpairs(reflist_struct *, thresh_struct *, model_struct *,
                             int, int, int),
		get_overpairs(overlist_struct *, thresh_struct *, 
                              model_struct *, int, int, int);

#endif
