#include <stdio.h>
#include <string.h>
#include "fitscat.h"
#include "options_globals.h"
#include "utils_globals.h"

#define NKEYS 5

/* 
   19.07.01:
   removed compiler warnings under DEC
*/

int load_field(tabstruct *tab, tabstruct *ftab, 
                float **x, char *xname, float **y, char *yname,
                float **p, char *photname, int **id, char *idname,
                int nfield, short int flag_mask)
{
     char       **keynames;
     keystruct	**keys;
     int	i, j, n;
     float	*fptr;
     float	*lx, *ly, *lp;
     int	*lid, *iptr;
     short int	*f;
     
     ED_CALLOC(keynames, "load_field", char *,      NKEYS);
     ED_CALLOC(keys,     "load_field", keystruct *, NKEYS); 
     for (i=0;i<NKEYS;i++) 
        ED_CALLOC(keynames[i], "load_field", char, MAXCHAR);
     strcpy(keynames[0], xname);
     strcpy(keynames[1], yname);
     strcpy(keynames[2], photname);
     strcpy(keynames[3], idname);
     strcpy(keynames[4], "Flag");
     n = read_field(tab, keynames, keys, NKEYS, nfield, ftab);
     VPRINTF(NORMAL,"Read %d objects of field %d\n",
             n, nfield);
     for (i=0;i<NKEYS;i++) {
        if (!keys[i])
           syserr(FATAL,"load_field", "No key %s in table\n",keynames[i]);
     }
     ED_CALLOC(lx,  "load_field", float, n);
     ED_CALLOC(ly,  "load_field", float, n);
     ED_CALLOC(lp,  "load_field", float, n);
     ED_CALLOC(lid, "load_field", int , n);
     for (i=0,fptr = keys[0]->ptr;i<n;i++) lx[i]  = fptr[i];
     for (i=0,fptr = keys[1]->ptr;i<n;i++) ly[i]  = fptr[i];
     for (i=0,fptr = keys[2]->ptr;i<n;i++) lp[i]  = fptr[i];
     for (i=0,iptr = keys[3]->ptr;i<n;i++) lid[i] = iptr[i];
     f   = keys[4]->ptr;
     for (i=0,j=0;i<n;i++) {
       if (!(f[i] & flag_mask)) {
          lx[j]  = lx[i];
          ly[j]  = ly[i];
          lp[j]  = lp[i];
          lid[j] = lid[i];
          j++;
       }
     }
     *x  = lx;
     *y  = ly;
     *p  = lp;
     *id = lid;
     for (i=0;i<NKEYS;i++) {
        ED_FREE(keynames[i]);
        ED_FREE(keys[i]->ptr);
     }
     ED_FREE(keynames);
     ED_FREE(keys);
     return j;
}

