typedef struct {
   float        **alpha,        /* Design matrix or covariance matrix */
                **beta;         /* Data matrix or solved parameters */
   float        **params;       /* Current parameters */
   int          *parnum,        /* Number of parameters per camera */
                *paroff;        /* Offset camera in parameter list */
   double       ***centers;     /* List of field centers */
   float        ***crpix;       /* List of reference pixels */
   float        xscale,         /* Estimate of x-coordinate plate scale */
                yscale;         /* Estimate of y-coordinate plate scale */
   char         **names;        /* List of parameter names */
   int          nf,             /* # of frames in the data */
                mf,             /* Maximum frame number in data */
                np,             /* # of free params in the solution */
                ncam,           /* # of cameras in the solutions */
                *bands,         /* Band numbers */
                pdeg,           /* Polynomial degree of plate model */
                ffdeg[3],       /* Polynomial degree of frame model */
                mfdeg,          /* Maximum number of degrees frame cheb. */
                mpix;           /* Pixel scaling parameter */
} model_struct;

