#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>
/* 
   03.01.2000 (TE):
   the following line is necessary for the MPA AIX
   system: the time.h file was not in the sys
   subdir. but in the parent dir.
*/
#include <time.h>
#ifdef SysV
#include <limits.h>
#include <sys/times.h>
#else
#include <sys/resource.h>
#endif
#include "timing_globals.h"
double cpu_so_far()
{
#ifdef SysV
  struct tms tms;

  times(&tms);
  return ((double) tms.tms_utime) / ((double) CLK_TCK) +
    ((double) tms.tms_stime) / ((double) CLK_TCK);

#else
  struct rusage rusage;

  getrusage(RUSAGE_SELF, &rusage);
  return
    ((double) rusage.ru_utime.tv_sec) +
      (((double) rusage.ru_utime.tv_usec) / 1000000.0) +
        ((double) rusage.ru_stime.tv_sec) +
          (((double) rusage.ru_stime.tv_usec) / 1000000.0);
#endif
}
