#include "imred.h"

/* 25.07.00:
   changed modeoverscan from int to PIXTYPE

   26.07:
   changed the flat correction so that for values
   where the flat is smaller than subst nothing happens
   to the image (w.r.t. flatfielding)

   01.08:
   included fringing stuff

   25.07.03:
   chnaged the occurences of mod2d (member of the ovscan
   struct) to its new name 'modline'

   23.01.05:
   I rearranged definitions of global variables to avoid
   double definitions during the linking process.
*/
/*----------------------------------------------------------------------------*/
void ccdred_image()
{
register short i,j;
float x,xf;
PIXTYPE modeoverscan=0.0;

   fseek(input.imagefile,(raster.ymin*input.nx+raster.xmin)*input.bytepix,1);

   for(i=0;i<output.ny;i++) 
   {
       read_file(&(input), filein, output.nx);
       fseek(input.imagefile,(input.nx-output.nx)*input.bytepix,1);
       if(mask.domask)
       {
          read_file(&(mask), filemk, output.nx);
       }
       if(input.doover) 
       {
          if(ovscan.modline)
             modeoverscan = overscan[0][i+raster.ymin];
          else
             modeoverscan = ovscan.median;
       }
       if(dark.dodark && darktab.file)
       {
          read_file(&(dark), filedk, output.nx);
       }
       if(flat.doflat)
       {
          read_file(&(flat), filefl, output.nx);
       }
       if(fringe.dofringe)
       {
          read_file(&(fringe), filefr, output.nx);
       }

       for(j=0;j<output.nx;j++) 
       {
	    x=filein[j];
 
            if(input.doover)
	    {
	       x-=modeoverscan;
	    }

	    if(dark.dodark && darktab.file) 
            {
	       x-=(filedk[j]*dark.fact);
	    }
            else if (dark.dodark && !darktab.file)
	    {
	       x-=current_dark;
	    }

	    if(fringe.dofringe) 
            {
	      x-=(filefr[j]*fringe.fact);
            }

	    if(flat.doflat) 
            {
	       xf=filefl[j];

	       if(fabs(xf) > flat.flatsubst)
	       {
	          x*=(flat.fact/xf);
		  /* xf=1.0; */
	       }
            }

            if(mask.domask) 
            {
               x*=filemk[j];
            }

	    filein[j]=x;
        }

        write_file(&(output),filein,output.nx);

        if(i%100==0)
	{
           fprintf(stderr," line %d to %d\r",i,output.ny);
	}
   }
   fprintf(stderr,"                           \r");
}


