/* 22.08.:
   substitutes fquickSOrt by the NRC routine 

   16.10.:
   simplifications:
   - the array tab enters the procedure ccdsigmaclip already sorted.
     Hence it is not necessary to sort it again and also the checking
     whether elements fall within the clip region can be done simply.

   07.02.03:
   - corrected an error in while((tab[i] <= max) && (i<nbre_o)).
     The term i<nbre_o has to be evaluated BEFORE tab[i] !!!!!
     Otherwise a Segmentation fault may occur.

   24.04.03:
   included the stdlib library to avoid warnings due to the
   undefined 'exit' function.

   01.07.2004:
   the median is now estimated as the mean of two middle
   elements from an array if the number of array elements
   is even.
*/

#include <stdlib.h>
#include "imcombflat.h"

/* 
   10.03.01:
   removed all compiler warnings under DEC
*/

/*----------------------------------------------------------------------------*/
float ccdsigmaclip(tab,nbre_in,verbose)
float *tab;
int nbre_in;
int verbose;
{
extern struct CLIPPING clipping;

int i,nbre_o,nbre_s;
int eject;
float sigma,median,mean,rnoise_term;
float min,max;
float pixel=0.0;

   /* Readout noise term in the CCD noise equation in ADU (input in e-) */
   rnoise_term = (clipping.noise/clipping.gain)*(clipping.noise/clipping.gain);

   nbre_o=nbre_in;
   nbre_s=nbre_in;

   if(nbre_s>2) 
   {
      eject=1;
      while(eject==1) 
      {
	/*sort((unsigned long)nbre_o, tab-1);*/
         /*fquickSort(tab,0,nbre_o-1);*/

	 if((nbre_s % 2) == 1)
	 { 
           median = tab[((nbre_o-1)/2)];
	 }
	 else
	 {
           median = (tab[((nbre_o)/2)]+tab[((nbre_o-1)/2)])/2.;
	 }

         if(clipping.ccdclip == 0) {
            sigma=0;
            for(i=0; i<nbre_o; i++)
	    {
               sigma += ((tab[i]-median)*(tab[i]-median));
	    }
	    sigma = sqrt(sigma/nbre_o);
         }
	 else {
            /* CCD noise equation - noise in e- to be converted in ADU */
	    sigma=sqrt( median/clipping.gain + 
                        rnoise_term       +
                        (clipping.e_rqe*median)*(clipping.e_rqe*median));
         }

         min = median - clipping.lsigmas*sigma;
         max = median + clipping.hsigmas*sigma;

         nbre_s=0;
         mean=0;
         i=0;
 
         while((i<nbre_o) && (tab[i] <= max))
	 {
            if((tab[i]>=min)) 
            {
               tab[nbre_s++]=tab[i];
               mean+=tab[i];
            }
            i++;
	 }

	 /* VERBOSE */
         if(verbose != 0) {
            printf("-> median=%.1f sigma=%.1f with %d values, keep %d values\n",
                   median,sigma,nbre_o,nbre_s);
         }

         if((nbre_s==nbre_o)||(nbre_s<=2))
            eject=0;
         else
            nbre_o=nbre_s;
      }
   }

   if(nbre_s>2) 
   {
      if(clipping.median == 0)        /* mean */
         pixel=mean/nbre_s;
      else if(clipping.median == 1) { /* median */
	/* fquickSort(tab,0,nbre_s-1); */
        /* sort((unsigned long)nbre_s, tab-1); */
	 if((nbre_s % 2) == 1)
	 { 
           pixel = tab[((nbre_s-1)/2)];
	 }
	 else
	 {
           pixel = (tab[((nbre_s)/2)]+tab[((nbre_s-1)/2)])/2.;
	 }
         /*pixel=tab[(nbre_s-1)/2];*/
      }
      else if(clipping.median == 2) { /* minimum */
	/* fquickSort(tab,0,nbre_s-1); */
        /* sort((unsigned long)nbre_s, tab-1); */
         pixel=tab[0];
      }
   }
   else if(nbre_s==2) 
   {
      if(clipping.median == 0)		/* mean */
	 pixel=(tab[0]+tab[1])/2;
      else {				/* median and minimum */
         if(tab[0]>tab[1])
            pixel=tab[1];
         else
            pixel=tab[0];
      }
   }
   else if(nbre_s==1) 
   {
      pixel=tab[0];
   }
   else if(nbre_s==0) 
   {
      printf("this should not happen !!!!!\n");
      exit(1);
   }

   return(pixel);
}

/*----------------------------------------------------------------------------*/
