typedef struct {
   float	xobj1, /* x-coordinate of first object of overlap pair */
		xobj2, /* x-coordinate of second object of overlap pair */
		yobj1, /* y-coordinate of first object of overlap pair */
		yobj2, /* y-coordinate of second object of overlap pair */
		eobj1, /* position error of first object of overlap pair */
		eobj2; /* position error of second object of overlap pair */
   int		f1,    /* frame number of first object of overlap pair */
		f2,    /* frame number of second object of overlap pair */
		c1,    /* camera number of first object of overlap pair */
		c2;    /* camera number of second object of overlap pair */ 
} overpair_struct;

typedef struct {
   overpair_struct **p;	 /* List of pointers to overlap pair structures */
   int            npair, /* Number of overlap pairs in the list */
                  ncur;  /* Current pointer in the overlap pairs list */
} overlist_struct;

typedef struct {
   double	ra,    /* Right Ascenscion of reference source */
		dec;   /* Declination of reference source */
   float	err,   /* Position error of reference source */
                xobj,  /* x-coordinate of extracted object */
                yobj,  /* y-coordinate of extracted object */
                eobj;  /* position error of extracted object */
   int		f,     /* frame number of extracted object */
		c;     /* camera number of extracted object */
} refpair_struct;

typedef struct {
   refpair_struct **p;	 /* List of pointers to reference pair structures */
   int            npair, /* Number of reference pairs in the list */
                  ncur;  /* Current pointer in the reference pairs list */
} reflist_struct;
