#include <stdio.h>
#include <math.h>

void coepro(double ra, double dec, double raref, double decref, 
            double rpp, double *x, double *y)
{
    double	rthea, gamby2,a,b,c,phi,an,rap,v,tthea,c01,c02,c03,c04,ansq;

    ra     = ra *3.14159625/180.0;
    dec    = dec *3.14159625/180.0;
    raref  = raref *3.14159625/180.0;
    decref = decref *3.14159625/180.0;
    rpp    = rpp *3.14159625/180.0;
    gamby2 = sin(decref);
    tthea  = tan(decref);
    rthea  = 1.0/tthea;
    a      = -2.0*tthea;
    b      = tthea * tthea;
    c      = tthea/3.0;

    c01    = a/2.0;
    c02    = -1.0/8.0*a*a+b/2.0;
    c03    = -1.0/4.0*a*b+1.0/16.0*a*a*a+c/2.0;
    c04    = -1.0/8.0*b*b-1.0/4.0*a*c+3.0/16.0*b*a*a-5.0/128.0*a*a*a*a;

    phi    = raref-ra;
    an     = phi*gamby2;
    v      = dec-decref;
    rap    = rthea*(1.0+v*(c01+v*(c02+v*(c03+v*c04))));
    ansq   = an*an;
    *x     = rap*an*(1.0-ansq/6.0)/rpp;
    *y     = (rthea-rap*(1.0-ansq/2.0))/rpp;
}

