#include "flips.h"

/*
   16.09.01:
   - an argument giving the name of the ini-file has now to be
     given as argument (this was necessary to make the code
     useable in parallel mode

   25.07.03:
   the definition of 'median_overscan' was modified to include
   the minreject and maxreject parameters

   23.01.05:
   I rearranged definitions of global variables to avoid
   double definitions during the linking process.

   09.09.2005:
   I removed superfluous arguments (xmin, xmax) from smooth_overscan
*/

extern PIXTYPE *filein,*filedk,*filefl,*filemk,*filefr;          /* buffer for one image line */
extern PIXTYPE **overscan; 		                /* the overscan buffer */

extern float current_dark; /* current dark current if value from a table */

/* data structures */
extern struct IMAGE input,output,dark,flat,mask,fringe;
extern struct OVERSCAN ovscan;
extern struct DARKTAB darktab;
extern struct RASTER raster;

/* function definitions */
void init_para(char *ainifile);
void fitsopen();
void fitsclose(int fill_file);
void fitsalloc();
void find_overscan();
void load_overscan(PIXTYPE **overscan,int xmin,int xmax,int ymin,int ymax);
void ccdred_image();
void median_overscan(PIXTYPE **overscan,int xmin,int xmax,int ymin,int ymax,
                     int minreject, int maxreject);
void smooth_overscan(PIXTYPE **overscan,int ymin,int ymax);






