typedef struct {
    char	*ptr;
    int		nblocks, curline, curpos;
} fitshead_struct;

typedef struct {
    FILE	*fd;		/* File handle of FITS image file */
    char	name[MAXCHAR];  /* The FIST filename */
    double	xcen,		/* Central x coordinate reference */
		ycen,		/* Central y coordinate reference */
		dx,		/* Pixel x dimension in reference frame */
		dy,		/* Pixel y dimension in reference frame */
		bscale,		/* FITS data scaling */
		bzero;		/* FITS data offset */
    int		curline,	/* Image line number currently read */
		xwid,		/* Image x coordinate width */
		ywid,		/* Image y coordinate width */
		bitpix,		/* Number of bits per pixel in FTS file */
                bit_sign, 	/* Signed or unsigned integer values */
		px0,		/* x pixel number of reference */
		py0,		/* y pixel number of reference */
                comp_type,      /* DENIS specific compression type */
                code_len;       /* Length of compressed image */
    t_type	pix_type;       /* Internal representation of pixels */
    fitshead_struct *head;	/* The actual fits header text information */
} fitsfile_struct;

