/* 
   History:

   26.10.01:
   introduced minobj to the control structure.
   It gives the minimum number of objects that have
   to be in common in two overlapping frames so that
   this overlap is considered in the relphotom
   process
*/

#ifndef MAXCHAR
#define MAXCHAR 255
#endif
#define MAXFILES 100

typedef struct {
    char listfile[MAXCHAR];
    char pairfile[MAXCHAR];
    char reffile[MAXFILES][MAXCHAR];
    char fixedfile[MAXCHAR];
    char outfile[MAXCHAR];
    char conffile[MAXCHAR];
    char airmass[MAXCHAR];
    char crval1[MAXCHAR];
    char crval2[MAXCHAR];
    char xpos[MAXCHAR];
    char ypos[MAXCHAR];
    char fpos[MAXCHAR];
    char row[MAXCHAR];
    char col[MAXCHAR];
    char zp[MAXCHAR];
    char coef[MAXCHAR];
    char mags[MAXCHAR];
    char field[MAXCHAR];
    char magerrs[MAXCHAR];
    char flag[MAXCHAR];
    char fitsfile[MAXCHAR];
    int  flag_mask;
    char imaflags[MAXCHAR];
    char method[MAXCHAR];
    int  imaflags_mask;
    bool use_flag;
    int  ilist, rlist;
    int	 nobsmax, nobs, niter, nref;
    int  minobj;
    int	 npol_param;
    double minmag, maxmag, magdif, fixed_fact;
    bool fixed;
} control_struct;

typedef struct {
    int		*from_f, *to_f;		/* Field numbers */
    int		*from_flag, *to_flag;	/* Flag values */
    int		*from_imaflag, *to_imaflag;	/* IMAFLAGS_ISO values */
    short int	*from_chan, *to_chan;	/* Channel numbers */
    float	**from_m, **to_m;	/* Magnitudes */
    float	**from_e, **to_e;	/* Magnitude errors */
    int		nc;			/* Number of unique fields */
    int		nover;			/* Number of true overlaps */
    int		nobjs;			/* Number of objects in arrays */
    int		*indx;			/* Indirect indexes */
    int		*iind, *jind;		/* Row/col indices */
} pair_struct;
