/*
 * HISTORY COMMENTS:
 *
 * 27.05.2010:
 * removal of compiler warnings
 */

#include "key.h"

#include "prefs_imred.h"

pkeystruct key[] =
 {
  {"BINNED", P_BOOL, &prefs.binnedsaveflag, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"BINNED_IMAGE", P_STRING, &prefs.binned, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"TRANSPOSE", P_BOOL, &prefs.transposesaveflag, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"TRANSPOSE_IMAGE", P_STRING, &prefs.transpose, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"RADON", P_BOOL, &prefs.radonsaveflag, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"RADONORIG_IMAGE", P_STRING, &prefs.radon_orig, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"RADONTRAN_IMAGE", P_STRING, &prefs.radon_tran, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"NOISE", P_BOOL, &prefs.noisesaveflag, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"NOISEORIG_IMAGE", P_STRING, &prefs.noise_orig, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"NOISETRAN_IMAGE", P_STRING, &prefs.noise_tran, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"SN", P_BOOL, &prefs.snsaveflag, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"SNORIG_IMAGE", P_STRING, &prefs.sn_orig, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"SNTRAN_IMAGE", P_STRING, &prefs.sn_tran, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"PMIN", P_FLOAT, &prefs.pmin, 0, 0, -10.0, 10.0, 
   {""}, 1, 1, NULL, 0},
  {"PMAX", P_FLOAT, &prefs.pmax, 0, 0, -10.0, 10.0, 
   {""}, 1, 1, NULL, 0},
  {"DELTAP", P_FLOAT, &prefs.deltap, 0, 0, 0.00001, 1.0, 
   {""}, 1, 1, NULL, 0},
  {"BINNING", P_INT, &prefs.binning, 1, 32, 0.0, 0.0,
   {""},1, 1, NULL, 0},
  {"FLAG", P_BOOL, &prefs.flagflag, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"FLAG_IMAGE", P_STRING, &prefs.flag, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"DATATHRESH", P_FLOAT, &prefs.datathreshold, 0, 0, 0.0, 1000000.0, 
   {""}, 1, 1, NULL, 0},
  {"ORIGPEAKS", P_STRING, &prefs.origpeaksfile, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"TRANPEAKS", P_STRING, &prefs.tranpeaksfile, 0, 0, 0.0, 0.0,
   {""}, 1, 1, NULL, 0},
  {"PEAKTHRESH", P_FLOAT, &prefs.peakthreshold, 0, 0, 1.0, 100.0, 
   {""}, 1, 1, NULL, 0},
  {"HIGHCUT", P_FLOAT, &prefs.highcut, 0, 0, 0.0, 100.0,
   {""}, 1, 1, NULL, 0},
  {"XSHIFT", P_FLOAT, &prefs.xshift, 0, 0, -100000000., 10000000.0,
   {""}, 1, 1, NULL, 0},
  {"YSHIFT", P_FLOAT, &prefs.yshift, 0, 0, -100000000., 10000000.0,
   {""}, 1, 1, NULL, 0},
  {"", P_BOOL, NULL, 0, 0, 0.0, 0.0, {""}, 1, 1, NULL, 0}
 };

char                    keylist[sizeof(key)/sizeof(pkeystruct)][16];

char *default_prefs[] =
{
"# Default configuration file for linedetect V1.0",
"#",
"# ----------- SAVE settings -----------------", 
"#",
"BINNED                   Y                    # save binned image (Y/N)",
"BINNED_IMAGE             binned.fits          # the name of the binned image",
"TRANSPOSE                Y                    # save transposed image (Y/N)",
"TRANSPOSE_IMAGE          transpose.fits       # the name of the transposed image",
"RADON                    Y                    # save transposed image (Y/N)",
"RADONORIG_IMAGE          radon_orig.fits      # the name of the radon transform",
"RADONTRAN_IMAGE          radon_tran.fits      # the name of the radon transform",
"                                              # from the transposed image",
"NOISE                    Y                    # save noise images (Y/N)",
"NOISEORIG_IMAGE          noise_orig.fits      # the name of the noise image",
"NOISETRAN_IMAGE          noise_tran.fits      # the name of the noise image",
"                                              # from the transposed image",
"SN                       Y                    # save SN image (Y/N)",
"SNORIG_IMAGE             sn_orig.fits         # the name of the SN image",
"SNTRAN_IMAGE             sn_tran.fits         # the name of the noise image",
"                                              # from the transposed image",
"ORIGPEAKS                orig.peaks           # the name of the ASCII file",
"                                              # listing peaks from original file",
"TRANPEAKS                tran.peaks           # the name of the ASCII file",
"                                              # listing peaks from original file",
"#",
"# ----------- settings for the radon transform -----------------", 
"#",
"FLAG                     N                    # flag input frame (Y/N)",
"FLAG_IMAGE               flag.fits            # flag image",
"DATATHRESH               10000.0              # pixels having a modulus larger than",
"                                              # this value are not considered in radon transform",
"PMIN                     -1.0                 # minimum slope",
"PMAX                      1.0                 # maximum slope",
"DELTAP                   0.01                 # increment in line slope (in original image)",
"HIGHCUT                     7                 # the number of pixels to reject from each line",
"                                              # (in percent)",
"BINNING                     8                 # binning factor for input frame",
"PEAKTHRESH                 12                 # threshhold for peaks to be listed",
"XSHIFT                    0.0                 # shift in x (original frame)",
"YSHIFT                    0.0                 # shift in y (original frame)",
""
};
