#!/usr/bin/env python

# python program to fit a simple, limnear colour transformation
# It is called by the script colortrans.sh.

import sys
import numpy as np
import scipy.optimize as so
import pylab

# the function to fit; here simpli linear without
# offset: y = c*x and we fit for c:
def fitfun(x, c):
    return c * x

infile = sys.argv[1]
tarfil = sys.argv[2]
sourcefil = sys.argv[3]
colfil1 = sys.argv[4]
colfil2 = sys.argv[5]
outplot = sys.argv[6]

data = np.loadtxt(infile)

x = data[:,1]
y = data[:,0]

param, cov = so.curve_fit(fitfun, x, y)

print param[0]
pylab.plot(x, y, 'o')

x1 = np.linspace(-1.0, 1.0, 20)
y1 = param[0] * x1

pylab.plot(x1, y1)
titlestr = "%s - %s = c * (%s - %s) with c = %.3f" % \
    (tarfil, sourcefil, colfil1, colfil2, param[0])
pylab.title(titlestr)
pylab.savefig(outplot)


