#!/usr/bin/env python

""" kcor.py: Calculate k-correction for a given SED
    (first argument) and a given filter (second argument).
    k-corrections are calculated from z = 0 .. 3.5.
"""

import sys
import numpy
import cosmology

if len(sys.argv) != 4:
    print "kcor.py sed filter result_file"
    sys.exit(1)
    
z = numpy.arange(0, 3.5, 0.025)
k = cosmology.kcor(z, sys.argv[1], sys.argv[2])

fout = open(sys.argv[len(sys.argv) - 1], "w")

for i in range(len(z)):
    fout.write("%.4f %.4f\n" % (z[i], k[i]))

fout.close()

