#!/freeware/bin/bash

# the script takes a list of FITS images as input 
# (one image per line) and creates KSB-LDAC catalogs
# in the dir. where it was invoked. The final catalogs
# end with ...anal.cat. The catalogs ending with ..._1.cat
# and ....tmp.cat are intermediate and can be deleted.

BINDIR=${PIPEBIN}/${EXT}

cat $1 |\
{
  while read file
  do
    BASE=`basename $file .fits`

    echo "working on: $file"
    echo "running newpeaks"
    nice ${BINDIR}/newpeaks $file > ${BASE}"_1.cat"
    echo "running hcat2ldac"
    nice ${BINDIR}/hcat2ldac -o ${BASE}"tmp.cat" < ${BASE}"_1.cat"
    echo "running analyseldac"
    nice ${BINDIR}/analyseldac -x 1 -r -3 -i ${BASE}"tmp.cat" -o ${BASE}"anal.cat"
  done
} 
