#!/freeware/bin/bash -xv

# the script takes the output of the astrometrix_convert
# program and writes the data into the image header (2nd
# argument). The script assumes that 'dfits', 'fitsort', 'awk',
# 'fitsedit' and 'replacekey' are in your path.


# $1: FITS image
# $2: ASCII file with header keywords

cat $2 |\
{
  while read word value
  do
    LINE="${word} ${value}"
    PRESENT=`dfits $1 | fitsort ${word} | awk '($1!="FILE") {print $2}'`

    if [ -z ${PRESENT} ]; then
      fitsedit -N -k ${word} -t FLOAT -e ${value} $1
    else
      FITSLINE=`echo "${LINE}" | awk '{printf("%-8s= %e\n"), $1, $2}'`
      replacekey $1 "${FITSLINE}" "${word}"
    fi
  done
}

