#!/usr/bin/env python

# The script takes a list of x, y coordinates and prints
# the pixel value at that position from a given FITS image

# HISTORY COMMNETS (TE)
# =====================
#
# 07.05.2009:
# The script now works with numpy (and with a numpy compatible
# version of pyfits!); it used numarray before.

import pyfits
from numpy import *
import string
import sys
import getopt

def usage():
    print "Usage:"
    print "apply_mag_lim.py -c input_catalogue -i input_image -o output_catalogue"
    print
    print "    -c, --cat=STRING          Input catalgue: three columns (SeqNr, Xpos, Ypos)"
    print "    -i, --inout=STRING        Input FITS image containing limiting magnitudes"
    print "    -o, --output=STRING       Output catalogue: two columns (SeqNr, mag_lim)"
    print
    return
    
if __name__ == "__main__":

    try:
        opts, args = getopt.getopt(sys.argv[1:],
                                   "c:i:o:",
                                   ["cat=", "input=", "output="])
    except getopt.GetoptError:
        usage()
        sys.exit(2)

    incat = infile = outcat = None
    for o, a in opts:
        if o in ("-c", "--cat"):
            incat = a
        if o in ("-i", "--input"):
            infile = a
        elif o in ("-o", "--output"):
            outfile = a

    img = pyfits.open(infile)
    d = img[0].data
    pos = open(incat, 'r')
    pos_lines = pos.readlines()
    pos.close()
    outcat = zeros((len(pos_lines), 2), 'f')
    outfile = open(outfile, 'w')

    for i in range(len(pos_lines)):
        words = string.split(pos_lines[i])
        outcat[i, 0] = string.atof(words[0])

        if int(string.atof(words[2])) >= d.shape[0]:
            outcat[i,1] = d[int(string.atof(words[2])) - 1, \
                            int(string.atof(words[1]))]
        elif int(string.atof(words[1])) >= d.shape[1]:
            outcat[i,1] = d[int(string.atof(words[2])), \
                            int(string.atof(words[1]))-1]
        elif int(string.atof(words[1])) >= d.shape[1] and \
             int(string.atof(words[2])) >= d.shape[0]:
            outcat[i,1] = d[int(string.atof(words[2])) - 1, \
                            int(string.atof(words[1])) - 1]
        else:
            outcat[i,1] = d[int(string.atof(words[2])), \
                            int(string.atof(words[1]))]
            
        outfile.write(str(int(outcat[i,0])) + ' ' + str(outcat[i,1]) + '\n')
    outfile.close()
