 /*
 				globals.h

*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*
*	Part of:	EYE
*
*	Author:		E.BERTIN, IAP & Leiden observatory
*
*	Contents:	global declarations.
*
*	Last modify:	10/05/97
*
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#include	"types.h"

/*----------------------- miscellaneous variables ---------------------------*/
prefstruct		prefs;
char			gstr[MAXCHAR];

/*------------------------------- functions ---------------------------------*/
extern void		closecheck(void),
			endcheck(picstruct *field),
			endfield(picstruct *),
			error(int, char *, char *),
			initcheck(picstruct *, char *),
			makebplist(char **, char **, int),
			readdata(picstruct *, PIXTYPE *, int),
			readimagehead(picstruct *),
			swapbytes(void *, int, int),
			useprefs(void),
			warning(char *, char *),
			writecheck(PIXTYPE *, int);

extern char		*readfitshead(FILE *, char *, int *);

extern int		cistrcmp(char *, char *, int),
			copyimage(picstruct *, PIXTYPE *, int, int, int, int),
			findkeys(char *, char key[][16], int);

extern float		hmedian(float *, int);

extern double		rndbl(void);

extern PIXTYPE		*loadstrip(picstruct *);

extern picstruct	*newfield(char *);
