/*
 				interpolate.h

*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*
*	Part of:	Swarp
*
*	Author:		E.BERTIN (IAP)
*
*	Contents:	Include file for interpolate.c
*
*	Last modify:	28/02/2000
*
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#ifndef _FIELD_H_
#include "field.h"
#endif

#ifndef	_INTERPOLATE_H_
#define	_INTERPOLATE_H_

/*-------------------------------- macros -----------------------------------*/
/*------------------------------- constants ---------------------------------*/

#define	INTERP_MAXDIM		10	/* Max. number of image dimensions */
#define	INTERP_MAXKERNELWIDTH	 8	/* Max. range of kernel (pixels) */

/*--------------------------------- typedefs --------------------------------*/
typedef enum {INTERP_NEARESTNEIGHBOUR, INTERP_BILINEAR, INTERP_LANCZOS2,
		INTERP_LANCZOS3, INTERP_LANCZOS4}	interpenum;

/*-------------------------- structure definitions --------------------------*/

/*----------------------- miscellaneous variables ---------------------------*/
/*-------------------------------- protos -----------------------------------*/

extern int	interpolate_pix(fieldstruct *field, fieldstruct *wfield,
		double *pos, PIXTYPE *pixout, PIXTYPE *wpixout);

extern void	free_kernel(void),
		init_kernel(interpenum *interptype, int naxis),
		make_kernel(double pos, double *kernel, interpenum interptype);

#endif
