 /*
 				main.c

*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*
*	Part of:	SWarp
*
*	Author:		E.BERTIN (IAP)
*
*	Contents:	Parsing of the command line.
*
*	Last modify:	22/05/2000
*
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#include	<ctype.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"define.h"
#include	"globals.h"

#define         MAXINFIELD 8192
#define		SYNTAX \
"fitslimits input images -r reference image"

const char           notokstr[] = {" \t=,;\n\r\""};

/********************************** main ************************************/
int	main(int argc, char *argv[])

  {
   char		**argkey, **argval, *str;
   char         refimage_name[MAXCHAR];
   int		a, narg, nim;
   char          *(infield_name[MAXINFIELD]);/* Filename(s) of input images */
   int          ninfield;

  if (argc<2)
    {
    fprintf(OUTPUT, "\n		%s  Version %s (%s)\n", BANNER, VERSION, DATE);
    fprintf(OUTPUT, "\nFor information, please contact: %s\n", COPYRIGHT);
    error(EXIT_SUCCESS, "SYNTAX: ", SYNTAX);
    }
  QMALLOC(argkey, char *, argc);
  QMALLOC(argval, char *, argc);

/*default parameters */
  ninfield = 1;
  infield_name[0] = "image";
  narg = nim = 0;

  for (a=1; a<argc; a++)
    {
    if (*(argv[a]) == '-' && a<(argc-1))
      {
      if (strlen(argv[a])<3)
        switch((int)tolower((int)argv[a][1]))
          {
          case 'r':
            strcpy(refimage_name, argv[++a]);
            break;
          default:
            error(EXIT_SUCCESS,"SYNTAX: ", SYNTAX);
          }
      }
    else
      {
/*---- The input image filename(s) */
      for(; (a<argc) && (*argv[a]!='-'); a++)
        for (str=NULL;str=strtok(str?NULL:argv[a], notokstr); nim++)
          if (nim<MAXINFIELD)
            infield_name[nim] = str;
          else
            error(EXIT_FAILURE, "*Error*: Too many input images: ", str);
      ninfield = nim;
      a--;
      }
    }

  makeit(ninfield, infield_name, refimage_name);

  NFPRINTF(OUTPUT, "All done");
  NPRINTF(OUTPUT, "\n");

  exit(EXIT_SUCCESS);
  }




