#include "fits_image_io_defs.h"
#include "fits_image_io_types.h"

/* 16.07.01:
 * included definition of read_fits_line
 * included definition of write_fits_line
 * included definition of write_fits_header
 * included definition of fits_find
 * included definition of padd_fits
 */

extern fitsfile_struct 
		*open_fits_file(char *),
		*new_fits();

extern char	
                *r_fits_bool(char *, fitshead_struct *),
		*r_fits_str(char *, fitshead_struct *);

extern unsigned char
                *alloc_fits_map(int, int, t_type);

extern void 
		*interp_fits_image(fitsfile_struct *, bool),
		close_fits(fitsfile_struct *, bool),
		inherit_fits(fitsfile_struct *, fitsfile_struct *),
		w_fits_pad(fitshead_struct *),
		set_no_interp(bool),
		init_fits(fitsfile_struct *),
		save_fits(fitsfile_struct *, unsigned char *, char *);

extern int
		w_fits_bool_c(char *, fitshead_struct *, int, char *),
		w_fits_int_c(char *, fitshead_struct *, int, char *),
		w_fits_short_c(char *, fitshead_struct *, short int, char *),
		w_fits_float_c(char *, fitshead_struct *, float, char *),
		w_fits_double_c(char *, fitshead_struct *, double, char *),
		w_fits_str_c(char *, fitshead_struct *, char *, char *),
		w_fits_bool(char *, fitshead_struct *, int),
		w_fits_int(char *, fitshead_struct *, int),
		w_fits_short(char *, fitshead_struct *, short int),
		w_fits_float(char *, fitshead_struct *, float),
		w_fits_double(char *, fitshead_struct *, double),
		w_fits_str(char *, fitshead_struct *, char *),
                d_fits(char *, fitshead_struct *),
		r_fits_int(char *, fitshead_struct *, int),
		r_fits_short(char *, fitshead_struct *, short int),
		s_fits_bool_c(char *, fitshead_struct *, int, char *),
		s_fits_int_c(char *, fitshead_struct *, int, char *),
		s_fits_short_c(char *, fitshead_struct *, short int, char *),
		s_fits_float_c(char *, fitshead_struct *, float, char *),
		s_fits_double_c(char *, fitshead_struct *, double, char *),
		s_fits_bool(char *, fitshead_struct *, int),
		s_fits_int(char *, fitshead_struct *, int),
		s_fits_short(char *, fitshead_struct *, short int),
		s_fits_float(char *, fitshead_struct *, float),
		s_fits_double(char *, fitshead_struct *, double),
		s_fits_str(char *, fitshead_struct *, char *);

extern int      write_fits_header(fitsfile_struct *);
extern char    *fits_find(char *, fitshead_struct *);

extern void     read_fits_line(fitsfile_struct *, unsigned char *, int, bool),
                write_fits_line(fitsfile_struct *, unsigned char *);

extern double
		r_fits_float(char *, fitshead_struct *, double);

extern void     padd_fits(fitsfile_struct *);
