#ifndef _PREFS_H_
#define _PREFS_H_

#define MAXIMAGE                100
#ifndef MAXCHAR
#define MAXCHAR                 2560
#endif

/*
   23.01.2005:
   I changed the location of the actual prefstruct definition
   to avoid double existence of it during the link process.
*/



#define QMALLOC(ptr, typ, nel) \
                {if (!(ptr = (typ *)malloc((size_t)(nel)*sizeof(typ)))) \
                  error(1, "Not enough memory for ", \
                        #ptr " (" #nel " elements) !");;}

static const char		notokstr[] = {" \t=,;\n\r\""};

/* prefs stuff */
typedef struct
{
    char	  prefs_name[MAXCHAR];      /* prefs filename */
    char          inname[MAXCHAR];          /* the input filename */
    int           binning;
    int           binnedsaveflag;
    char          binned[MAXCHAR];
    int           transposesaveflag;
    char          transpose[MAXCHAR];
    int           radonsaveflag;
    char          radon_orig[MAXCHAR];
    char          radon_tran[MAXCHAR];
    int           noisesaveflag;
    char          noise_orig[MAXCHAR];
    char          noise_tran[MAXCHAR];
    int           snsaveflag;
    char          sn_orig[MAXCHAR];
    char          sn_tran[MAXCHAR];
    double        pmin;
    double        pmax;
    double        deltap;
    int           flagflag;
    char          flag[MAXCHAR];
    double        datathreshold;
    char          origpeaksfile[MAXCHAR];
    char          tranpeaksfile[MAXCHAR];
    double        peakthreshold;
    double        highcut;
    double        xshift;
    double        yshift;
}	prefstruct;

extern prefstruct	prefs;


/* function definitions */
extern int	cistrcmp(char *cs, char *ct, int mode);

extern void	dumpprefs(void);
extern void     readprefs(char *filename,char **argkey,char **argval,int narg);

extern void    error(int, char *, char *);
extern void    warning(char *msg1, char *msg2);

#endif






