#!/bin/bash -xv

#$1: Filename
#$2: min rg
#$3: max rg
#$4: min mag
#$5: max mag
#$6: imagename

. lensing.ini

BASE=`basename $1 _anisocorr.cat`

RGS="1.0 2.0 3.0 4.0 5.0 6.0 7.0 8.0 9.0"

${P_LDACFILTER} -i $1 -o tmp.cat -c "(cl=2);"

for RG in ${RGS}
do
  echo $RG 
  ${P_ANALYSELDAC} -i tmp.cat -o tmp1.cat -f $6 -r -3 -R ${RG}
  ${P_ANISOTROPY} -i tmp1.cat -o tmp12.cat -c rh $2 $3 mag $4 $5
  ${P_LDACFILTER} -i tmp12.cat -o tmp13.cat -c "(cl=2);"

  ${P_LDACCALC} -i tmp13.cat -o tmp2.cat \
           -c "(Psh11/Psm11);" -n "Psh11Psm11" "" -k DOUBLE \
           -c "(Psh22/Psm22);" -n "Psh22Psm22" "" -k DOUBLE \
           -c "(e1/Psm11);"    -n "e1Psm11" ""    -k DOUBLE \
           -c "(e2/Psm22);"    -n "e2Psm22" ""    -k DOUBLE
  rm tmp_asc.cat
  ${P_LDACTOASC} -i tmp2.cat -b -t OBJECTS -k Psh11Psm11 > tmp_asc.cat
  MEAN1=`${P_GAWK} 'BEGIN { x=0; s=0; } { x=x+$1; s=s+($1*$1); } END {x=x/NR; s=sqrt((s-NR*x*x)/(NR-1)); print x, s}' tmp_asc.cat` 
  echo ${MEAN1}
  rm tmp_asc.cat
  ${P_LDACTOASC} -i tmp2.cat -b -t OBJECTS -k Psh22Psm22 > tmp_asc.cat
  MEAN2=`${P_GAWK} 'BEGIN { x=0; s=0; } { x=x+$1; s=s+($1*$1); } END {x=x/NR; s=sqrt((s-NR*x*x)/(NR-1)); print x, s}' tmp_asc.cat` 
  echo ${MEAN2}
  rm tmp_asc.cat
  ${P_LDACTOASC} -i tmp2.cat -b -t OBJECTS -k e1Psm11 > tmp_asc.cat
  MEAN3=`${P_GAWK} 'BEGIN { x=0; s=0; } { x=x+$1; s=s+($1*$1); } END {x=x/NR; s=sqrt((s-NR*x*x)/(NR-1)); print x, s}' tmp_asc.cat` 
  echo ${MEAN3}
  rm tmp_asc.cat
  ${P_LDACTOASC} -i tmp2.cat -b -t OBJECTS -k e2Psm22 > tmp_asc.cat
  MEAN4=`${P_GAWK} 'BEGIN { x=0; s=0; } { x=x+$1; s=s+($1*$1); } END {x=x/NR; s=sqrt((s-NR*x*x)/(NR-1)); print x, s}' tmp_asc.cat` 
  echo ${MEAN4}
  echo ${RG}" "${MEAN1}" "${MEAN2}" "${MEAN3}" "${MEAN4} >> ${BASE}result.txt
done

rm tmp.cat
rm tmp2.cat
rm tmp13.cat
rm tmp12.cat

exit 0;
