#!/freeware/bin/bash -xv

# the script creates a LDAC catalog containing a
# DISTORTIONS table containing the PV polynomials
# of ASTROMETRIX. The script assumes that 'asctoldac'
# and 'gawk' are in your path.

# $1: the .head ASTROMETRIX header
# $2: the resulting LDAC catalog

# the script
rm tmp.asc

gawk -F = 'BEGIN {string="" } 
          {if($1 ~ /^[PC][DRV]/) 
           { string = string $2 "";
             printf("COL_NAME = %s\n", $1) > "tmp.asc"; 
             print "COL_TTYPE= DOUBLE" >> "tmp.asc";
             print "COL_HTYPE= FLOAT" >> "tmp.asc";
             print "COL_COMM = \"\"" >> "tmp.asc";
             print "COL_UNIT = \"\"" >> "tmp.asc";
             print "COL_DEPTH= 1" >> "tmp.asc" }
          } END { print string > "tmp1.asc" }' $1

asctoldac -i tmp1.asc -c tmp.asc -o test.cat -t DISTORTIONS\
          -b 1 -n "test"