#!/bin/bash 

# estimate limiting magnitudes from a file with two columns containing
# sigma and zeropoints.

# $1: file with zeropoints and statistics on the sky background variation
# $2: aperture (in arcsec)
# $3: sigma

. ./${INSTRUMENT:?}.ini

NPIX=`${P_GAWK} 'BEGIN {print '$2' * '$2' * 3.14159 / \
                        ('${PIXSCALE}' * '${PIXSCALE}')}'`

while read SKYSIGMA ZP
do
  LIMMAG=`${P_GAWK} 'BEGIN {
 print '${ZP}' - 2.5 * log(sqrt('${NPIX}') * '$3' * '${SKYSIGMA}') / log(10)}'`

  echo ${LIMMAG}
done < $1
