/*
 				imaout.c

*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*
*	Part of:	RetinaLearn1
*
*	Author:		E.BERTIN, IAP/DeNIS/LDAC
*
*	Contents:	Functions to handle the writing of the image(s).
*
*	Last modify:	10/11/96
*
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"define.h"
#include	"globals.h"
#include	"fitscat.h"
#include	"imaout.h"

/********************************* writeimage **********************************/
/*
Save the simulated frame.
*/
void	writeimage(picstruct *field, char *filename)

  {
   FILE		*file;
   char		*head, *line, *pad, *cptr, str[MAXCHAR];
   int		i,n, nbytes, ival;

/* Default header: the internal one */
  head = (char *)headima;
  n = sizeof(headima)/FBSIZE;
  i=0;

  ival = -32;
  if (fitswrite(head, "BITPIX  ", &ival, H_INT, T_LONG) != RETURN_OK)
    error(EXIT_FAILURE, "*Error*: missing BITPIX keyword in FITS header", "");
  ival = 2;
  if (fitswrite(head, "NAXIS   ", &ival, H_INT, T_LONG) != RETURN_OK)
    error(EXIT_FAILURE, "*Error*: missing NAXIS keyword in FITS header", "");
  if (fitswrite(head, "NAXIS1  ", &field->width, H_INT, T_LONG) != RETURN_OK)
    error(EXIT_FAILURE, "*Error*: missing NAXIS1 keyword in FITS header", "");
  if (fitswrite(head, "NAXIS2  ", &field->height, H_INT, T_LONG) != RETURN_OK)
    error(EXIT_FAILURE, "*Error*: missing NAXIS2 keyword in FITS header", "");

  if ((file = fopen(filename, "wb")) == NULL)
    error(-1,"*ERROR*: can't create ", filename);

  blankit(head, n*FBSIZE);
  QFWRITE(head, n*FBSIZE, file, filename);
  nbytes = field->npix*sizeof(PIXTYPE);
#if defined	BSWAP
  swapbytes(field->pix, sizeof(PIXTYPE), nbytes/sizeof(PIXTYPE));
#endif
  QFWRITE(field->pix, nbytes, file, filename);
  QCALLOC(pad, char, FBSIZE);
  nbytes = PADEXTRA(nbytes);
  if (nbytes)
    QFWRITE(pad, nbytes, file, filename);
  free(pad);
  if (i)
    free(head);
  fclose(file);

  return;
  }


