 /*
 				makeit.c

*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*
*	Part of:	EYE
*
*	Author:		E.BERTIN, IAP & Leiden observatory
*
*	Contents:	Main loop.
*
*	Last modify:	11/05/97
*
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/


#include	<math.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"define.h"
#include	"globals.h"
#include	"retina.h"

/********************************** makeit ***********************************/
/*
*/
void	makeit(char **inputnames, char **outputnames, int nb)

  {
   retinastruct	*retina;
   picstruct	*in, *out, *field[2];
   int		i, nfield, nstack;

  nfield = 2;
  NFPRINTF(OUTPUT, "Initializing the retina structure...");
  if (prefs.learn_type == LEARN_NEW)
    retina = new_retina(prefs.retina_size, prefs.nretina_size,
	prefs.nn_size, prefs.nnn_size, prefs.nsamp_max);
  else
    retina = load_retina(prefs.retina_name, prefs.nsamp_max);
  NFPRINTF(OUTPUT, "Examining frames...");
  for (i=0; i<nb; i++)
    {
    fprintf(OUTPUT, "Input-pair #%4d: \"%.30s\" & \"%.30s\"",
	i+1, inputnames[i],outputnames[i]);
/* Prepare image reading */
    field[0] = in = newfield(inputnames[i]);
    field[1] = out = newfield(outputnames[i]);
    if (in->width!=out->width || in->height!=out->height)
      error(EXIT_FAILURE, "*Error*: image size different from input in ",
	outputnames[i]);

/*-- Put it in the learning-list */
    nstack = feed_retina(retina, field, nfield, prefs.nsamp_max);
    free(in);
    free(out);

    if (nstack == prefs.nsamp_max)
      {
      warning("Pattern stack maximum reached in ", inputnames[i]);
      break;
      }
    }

  if (!nstack)
    error(EXIT_FAILURE, "*Error*: pattern stack empty","");
  train_retina(retina, prefs.niter/nstack,
	(float)prefs.learn_rate[0], (float)prefs.learn_rate[1]);
  NFPRINTF(OUTPUT, "Saving retina...");
  save_retina(retina, prefs.retina_name);
  end_retina(retina);
  NFPRINTF(OUTPUT,"Done.\n");

  return;
  }

