 /*
 				prefs.h

*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*
*	Part of:	EYE
*
*	Author:		E.BERTIN, IAP & Leiden observatory
*
*	Contents:	Keywords for the configuration file.
*
*	Last modify:	20/08/97
*
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

/*----------------------------- Internal constants --------------------------*/

#define	MAXLIST		32		/* max. nb of list members */

/* NOTES:
One must have:	MAXLIST >= 1 (preferably >= 16!)
*/

/*-------------------------------- misc flags -------------------------------*/

#define		FIND_STRICT	0
#define		FIND_NOSTRICT	1

/*-------------------------------- initialization ---------------------------*/
int	idummy;

pkeystruct key[] =
 {
  {"RETINA_NAME", P_STRING, prefs.retina_name},
  {"RETINA_SIZE", P_INTLIST, prefs.retina_size, 1, 1024, 0.0,0.0, {""},
     1,2, &prefs.nretina_size},
/*
  {"OUTPUT_TYPE", P_KEY, &prefs.out_type, 0,0, 0.0,0.0,
   {"RELATIVE", "ABSOLUTE", "BINARY"}},
*/
  {"LEARNING_TYPE", P_KEY, &prefs.learn_type, 0,0, 0.0,0.0,
   {"NONE","NEW", "RESUME", "RESTART"}},
  {"LEARNING_RATE", P_FLOATLIST, prefs.learn_rate, 0,0, 0.0, 1e6, {""},
     1,2, &prefs.nlearn_rate},
  {"NN_SIZE", P_INTLIST, &prefs.nn_size[1], 1, 1024, 0.0,0.0, {""},
     1,3, &prefs.nnn_size},
  {"PASSES", P_INT, &prefs.niter, 1,2000000000},
  {"BUFFER_MAXSIZE", P_INT, &prefs.nsamp_max, 1,2000000000},
  {"BACK_SIZE", P_INTLIST, prefs.backsize, 1,2000000000, 0.0,0.0,
    {""}, 1,2, &prefs.nbacksize},
  {"BACK_FILTERSIZE", P_INTLIST, prefs.backfsize, 1,7, 0.0,0.0,
    {""}, 1,2, &prefs.nbackfsize},
  {"FRAME_LIMITS", P_INTLIST, prefs.lim, 1, 2000000000, 0.0,0.0, {""},
     1,4, &prefs.nlim},
  {"CHECKIMAGE_TYPE", P_KEY, &prefs.check_type, 0,0, 0.0,0.0,
   {"NONE", "FILTERED", "RESIDUALS", "HISTOGRAM"}},
  {"CHECKIMAGE_NAME", P_STRING, prefs.check_name},
  {"VERBOSE_TYPE", P_KEY, &prefs.verbose_type, 0,0, 0.0,0.0,
   {"QUIET","NORMAL","FULL",""}},
  {""}
 };

char		keylist[sizeof(key)/sizeof(pkeystruct)][16];
